package com.zhuangzi.admin.sort;

import com.zhuangzi.tools.Db;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.ResultSet;
import java.sql.SQLException;

@WebServlet(name = "SortAddServlet",value="/sortAdd")
public class SortAddServlet extends HttpServlet {
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        response.setContentType("text/html;charset=utf-8");
        PrintWriter out = response.getWriter();
        request.setCharacterEncoding("utf-8");
        int parentid = Integer.valueOf(request.getParameter("parentid"));
        String sortname = request.getParameter("sortname");
        if(sortname.equals("")){
            out.println("<script>alert('类别名称不能为空');history.back();</script>");
            return;
        }
        int orders = Integer.valueOf(request.getParameter("orders"));
        //查询该父类下是否有重复的类名  begin
        try {
            String sql = "select id from sorts where parentid = ? and sortname = ?";
            ResultSet rs = Db.fetch(sql, parentid,sortname);
            if(rs.next()){
                out.println("<script>alert('父类下已存在相同类别!!');history.back();</script>");
                return;
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }

        //查询该父类下是否有重复的类名  end

        //设置level, sortpath 信息  begin
        int level = 1;
        String sortpath = "0,";
        if(parentid != 0){
            try {
                //最顶级时使用默认设置值, 否则根据父级来决定
                String sql = "select level, sortpath from sorts where id = ?";
                ResultSet rs = Db.fetch(sql,parentid);
                if(rs.next()){
                     level = rs.getInt("level") + 1;
                     sortpath = rs.getString("sortpath"); //暂时为父级sortpath, 当添加后, 更新 增加所属id
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
        //设置level, sortpath 信息  end

        //将信息添加到数据库sorts中 并返回新记录的id  begin
         String sql = "insert into sorts (sortname, parentid, sortpath, level, orders) values(?,?,?,?,?)";
         int id = Db.lastInsertId(sql,sortname,parentid,sortpath,level,orders);
        //将信息添加到数据库sorts中  end

        //更新sortpath begin
         Db.exec( "update sorts set sortpath = ? where id = ?",sortpath + id + ",",id);
        //更新sortpath end
         Db.close();
         out.println("<script>alert('添加成功');location.href='/sortList';</script>");
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String pid = request.getParameter("pid");
        int currentId = 0;
        if(pid != null){
            currentId = Integer.valueOf(pid);
        }
        StringBuffer selects = SortAll.selectTrees(0,currentId);
        request.setAttribute("selects",selects);
        request.getRequestDispatcher("/admin/sort/add.jsp").forward(request,response);
    }
}
