package com.zhuangzi.admin.sort;

import com.zhuangzi.tools.Db;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

public class SortAll {
    public static ArrayList<Map> all;  //存储所有的数据
    //pid :  父类ID, 查询当前类别下的子类
    //space    :  //分隔符
    //table    :  查询的类别表名
    public static int initLevel = 0;
    public  static ArrayList<Map> getChildren(int pid,String space, ArrayList<Map> arr){
        if(arr == null){
            String sql = "select * from sorts where id = ? order by orders asc ";
            ResultSet rs = Db.fetch(sql,pid);
            try{
                if(rs.next()) initLevel = rs.getInt("level");
            }
            catch (SQLException e){}
            //第一次,查询出来一级类别
                  sql = "select * from sorts where parentid = ? order by orders asc ";
                  rs  = Db.fetch(sql,pid);
            arr = addToList(rs);
            all = new ArrayList<>(); //第一次时,初始化 避免刷新调用重新加载
        }
        if(arr != null){
            for(Map mp:arr){
                //根据级别不一样, 在前面加上相应的分隔符
                int level = (int) mp.get("level");
                if(level == initLevel){
                    mp.put("space","");
                }
                else if(level == initLevel + 1){
                    space = "　　|---->";
                    mp.put("space",space);
                }
                else{
                    mp.put("space",space);
                }
                all.add(mp);
                pid = (int) mp.get("id");
                String sql = "select * from sorts where parentid = ? order by orders asc ";
                ResultSet  rs  = Db.fetch(sql,pid);
                arr = addToList(rs);
                if(arr != null){
                    getChildren(pid,"　　|"+ space,arr);
                }
            }
        }
        return all;
    }

    public static ArrayList<Map> addToList(ResultSet rs){
        ArrayList<Map> al = new ArrayList<>();
        try {
            while(rs.next()){
                Map<String,Object> hp = new HashMap();
                hp.put("id",rs.getInt("id"));
                hp.put("sortname",rs.getString("sortname"));
                hp.put("parentid",rs.getInt("parentid"));
                hp.put("sortpath",rs.getString("sortpath"));
                hp.put("level",rs.getInt("level"));
                hp.put("orders",rs.getInt("orders"));
                al.add(hp);
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        Db.close();
        return  al;
    }
    //得到无限分类的select下拉列表
    //pid : 父id
    //currenId : 被选择的id, 没有的话,传递0
    public static StringBuffer selectTrees(int pid,int currentId){
        StringBuffer sBuffer  = new StringBuffer();
        ArrayList<Map> results = SortAll.getChildren(pid,"",null);
        if(results != null){
            for(Map m:results){
                int id= (int) m.get("id");
                if(id == currentId){
                    sBuffer.append("<option value='"+id+"' style='background-color: #E20A0A; color:#fff' selected>" +
                            m.get("space") + m.get("sortname")+"</option> \n");
                }
                else{
                    sBuffer.append("<option value='"+id+"'>" +
                            m.get("space") + m.get("sortname")+"</option> \n");
                }
            }

        }
        return sBuffer;
    }
}
